
# Autogenerated by mlir-tblgen; don't manually edit.

from ._ods_common import _cext as _ods_cext
from ._ods_common import (
    SubClassValueT as _SubClassValueT,
    equally_sized_accessor as _ods_equally_sized_accessor,
    get_default_loc_context as _ods_get_default_loc_context,
    get_op_result_or_op_results as _get_op_result_or_op_results,
    get_op_result_or_value as _get_op_result_or_value,
    get_op_results_or_values as _get_op_results_or_values,
    segmented_accessor as _ods_segmented_accessor,
)
_ods_ir = _ods_cext.ir

import builtins
from typing import Sequence as _Sequence, Union as _Union


@_ods_cext.register_dialect
class _Dialect(_ods_ir.Dialect):
  DIALECT_NAMESPACE = "om"
  pass


@_ods_cext.register_operation(_Dialect)
class AnyCastOp(_ods_ir.OpView):
  OPERATION_NAME = "om.any_cast"

  _ODS_REGIONS = (0, True)

  def __init__(self, input, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(input))
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def input(self):
    return self.operation.operands[0]

  @builtins.property
  def result(self):
    return self.operation.results[0]

def any_cast(input, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(AnyCastOp(input=input, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class BasePathCreateOp(_ods_ir.OpView):
  OPERATION_NAME = "om.basepath_create"

  _ODS_REGIONS = (0, True)

  def __init__(self, basePath, target, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(basePath))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["target"] = (target if (
    issubclass(type(target), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('FlatSymbolRefAttr')) else
      _ods_ir.AttrBuilder.get('FlatSymbolRefAttr')(target, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def basePath(self):
    return self.operation.operands[0]

  @builtins.property
  def target(self):
    return self.operation.attributes["target"]

  @target.setter
  def target(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["target"] = value

  @builtins.property
  def result(self):
    return self.operation.results[0]

def basepath_create(base_path, target, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(BasePathCreateOp(basePath=base_path, target=target, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ClassExternFieldOp(_ods_ir.OpView):
  OPERATION_NAME = "om.class.extern.field"

  _ODS_REGIONS = (0, True)

  def __init__(self, sym_name, type_, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["sym_name"] = (sym_name if (
    issubclass(type(sym_name), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('SymbolNameAttr')) else
      _ods_ir.AttrBuilder.get('SymbolNameAttr')(sym_name, context=_ods_context))
    attributes["type"] = (type_ if (
    issubclass(type(type_), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('TypeAttr')) else
      _ods_ir.AttrBuilder.get('TypeAttr')(type_, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def sym_name(self):
    return self.operation.attributes["sym_name"]

  @sym_name.setter
  def sym_name(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["sym_name"] = value

  @builtins.property
  def type_(self):
    return self.operation.attributes["type"]

  @type_.setter
  def type_(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["type"] = value

def class_extern_field(sym_name, type_, *, loc=None, ip=None) -> _ods_ir.Operation:
  return _get_op_result_or_op_results(ClassExternFieldOp(sym_name=sym_name, type_=type_, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ClassExternOp(_ods_ir.OpView):
  OPERATION_NAME = "om.class.extern"

  _ODS_REGIONS = (1, True)

  def __init__(self, sym_name, formalParamNames, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["sym_name"] = (sym_name if (
    issubclass(type(sym_name), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('SymbolNameAttr')) else
      _ods_ir.AttrBuilder.get('SymbolNameAttr')(sym_name, context=_ods_context))
    attributes["formalParamNames"] = (formalParamNames if (
    issubclass(type(formalParamNames), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrArrayAttr')) else
      _ods_ir.AttrBuilder.get('StrArrayAttr')(formalParamNames, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def sym_name(self):
    return self.operation.attributes["sym_name"]

  @sym_name.setter
  def sym_name(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["sym_name"] = value

  @builtins.property
  def formalParamNames(self):
    return self.operation.attributes["formalParamNames"]

  @formalParamNames.setter
  def formalParamNames(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["formalParamNames"] = value

  @builtins.property
  def body(self):
    return self.regions[0]

def class_extern(sym_name, formal_param_names, *, loc=None, ip=None) -> _ods_ir.Operation:
  return _get_op_result_or_op_results(ClassExternOp(sym_name=sym_name, formalParamNames=formal_param_names, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ClassFieldOp(_ods_ir.OpView):
  OPERATION_NAME = "om.class.field"

  _ODS_REGIONS = (0, True)

  def __init__(self, sym_name, value, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(value))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["sym_name"] = (sym_name if (
    issubclass(type(sym_name), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('SymbolNameAttr')) else
      _ods_ir.AttrBuilder.get('SymbolNameAttr')(sym_name, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def value(self):
    return self.operation.operands[0]

  @builtins.property
  def sym_name(self):
    return self.operation.attributes["sym_name"]

  @sym_name.setter
  def sym_name(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["sym_name"] = value

def class_field(sym_name, value, *, loc=None, ip=None) -> _ods_ir.Operation:
  return _get_op_result_or_op_results(ClassFieldOp(sym_name=sym_name, value=value, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ClassOp(_ods_ir.OpView):
  OPERATION_NAME = "om.class"

  _ODS_REGIONS = (1, True)

  def __init__(self, sym_name, formalParamNames, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["sym_name"] = (sym_name if (
    issubclass(type(sym_name), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('SymbolNameAttr')) else
      _ods_ir.AttrBuilder.get('SymbolNameAttr')(sym_name, context=_ods_context))
    attributes["formalParamNames"] = (formalParamNames if (
    issubclass(type(formalParamNames), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrArrayAttr')) else
      _ods_ir.AttrBuilder.get('StrArrayAttr')(formalParamNames, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def sym_name(self):
    return self.operation.attributes["sym_name"]

  @sym_name.setter
  def sym_name(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["sym_name"] = value

  @builtins.property
  def formalParamNames(self):
    return self.operation.attributes["formalParamNames"]

  @formalParamNames.setter
  def formalParamNames(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["formalParamNames"] = value

  @builtins.property
  def body(self):
    return self.regions[0]

def class_(sym_name, formal_param_names, *, loc=None, ip=None) -> _ods_ir.Operation:
  return _get_op_result_or_op_results(ClassOp(sym_name=sym_name, formalParamNames=formal_param_names, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ConstantOp(_ods_ir.OpView):
  OPERATION_NAME = "om.constant"

  _ODS_REGIONS = (0, True)

  def __init__(self, value, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["value"] = (value if (
    issubclass(type(value), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('TypedAttrInterface')) else
      _ods_ir.AttrBuilder.get('TypedAttrInterface')(value, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def value(self):
    return self.operation.attributes["value"]

  @value.setter
  def value(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["value"] = value

  @builtins.property
  def result(self):
    return self.operation.results[0]

def constant(value, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(ConstantOp(value=value, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class EmptyPathOp(_ods_ir.OpView):
  OPERATION_NAME = "om.path_empty"

  _ODS_REGIONS = (0, True)

  def __init__(self, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def result(self):
    return self.operation.results[0]

def path_empty(*, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(EmptyPathOp(loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class FrozenBasePathCreateOp(_ods_ir.OpView):
  OPERATION_NAME = "om.frozenbasepath_create"

  _ODS_REGIONS = (0, True)

  def __init__(self, basePath, path, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(basePath))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["path"] = (path if (
    issubclass(type(path), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('OMPathAttr')) else
      _ods_ir.AttrBuilder.get('OMPathAttr')(path, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def basePath(self):
    return self.operation.operands[0]

  @builtins.property
  def path(self):
    return self.operation.attributes["path"]

  @path.setter
  def path(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["path"] = value

  @builtins.property
  def result(self):
    return self.operation.results[0]

def frozenbasepath_create(base_path, path, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(FrozenBasePathCreateOp(basePath=base_path, path=path, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class FrozenEmptyPathOp(_ods_ir.OpView):
  OPERATION_NAME = "om.frozenpath_empty"

  _ODS_REGIONS = (0, True)

  def __init__(self, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def result(self):
    return self.operation.results[0]

def frozenpath_empty(*, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(FrozenEmptyPathOp(loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class FrozenPathCreateOp(_ods_ir.OpView):
  OPERATION_NAME = "om.frozenpath_create"

  _ODS_REGIONS = (0, True)

  def __init__(self, targetKind, basePath, path, module, ref, field, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(basePath))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["targetKind"] = (targetKind if (
    issubclass(type(targetKind), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('TargetKind')) else
      _ods_ir.AttrBuilder.get('TargetKind')(targetKind, context=_ods_context))
    attributes["path"] = (path if (
    issubclass(type(path), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('OMPathAttr')) else
      _ods_ir.AttrBuilder.get('OMPathAttr')(path, context=_ods_context))
    attributes["module"] = (module if (
    issubclass(type(module), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrAttr')) else
      _ods_ir.AttrBuilder.get('StrAttr')(module, context=_ods_context))
    attributes["ref"] = (ref if (
    issubclass(type(ref), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrAttr')) else
      _ods_ir.AttrBuilder.get('StrAttr')(ref, context=_ods_context))
    attributes["field"] = (field if (
    issubclass(type(field), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrAttr')) else
      _ods_ir.AttrBuilder.get('StrAttr')(field, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def basePath(self):
    return self.operation.operands[0]

  @builtins.property
  def targetKind(self):
    return self.operation.attributes["targetKind"]

  @targetKind.setter
  def targetKind(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["targetKind"] = value

  @builtins.property
  def path(self):
    return self.operation.attributes["path"]

  @path.setter
  def path(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["path"] = value

  @builtins.property
  def module(self):
    return self.operation.attributes["module"]

  @module.setter
  def module(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["module"] = value

  @builtins.property
  def ref(self):
    return self.operation.attributes["ref"]

  @ref.setter
  def ref(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["ref"] = value

  @builtins.property
  def field(self):
    return self.operation.attributes["field"]

  @field.setter
  def field(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["field"] = value

  @builtins.property
  def result(self):
    return self.operation.results[0]

def frozenpath_create(target_kind, base_path, path, module, ref, field, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(FrozenPathCreateOp(targetKind=target_kind, basePath=base_path, path=path, module=module, ref=ref, field=field, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ListCreateOp(_ods_ir.OpView):
  OPERATION_NAME = "om.list_create"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, inputs, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(inputs))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def inputs(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def result(self):
    return self.operation.results[0]

def list_create(result, inputs, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(ListCreateOp(result=result, inputs=inputs, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class MapCreateOp(_ods_ir.OpView):
  OPERATION_NAME = "om.map_create"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, inputs, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(inputs))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def inputs(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def result(self):
    return self.operation.results[0]

def map_create(result, inputs, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(MapCreateOp(result=result, inputs=inputs, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ObjectFieldOp(_ods_ir.OpView):
  OPERATION_NAME = "om.object.field"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, object, fieldPath, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(object))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["fieldPath"] = (fieldPath if (
    issubclass(type(fieldPath), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('FlatSymbolRefArrayAttr')) else
      _ods_ir.AttrBuilder.get('FlatSymbolRefArrayAttr')(fieldPath, context=_ods_context))
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def object(self):
    return self.operation.operands[0]

  @builtins.property
  def fieldPath(self):
    return self.operation.attributes["fieldPath"]

  @fieldPath.setter
  def fieldPath(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["fieldPath"] = value

  @builtins.property
  def result(self):
    return self.operation.results[0]

def object_field(result, object, field_path, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(ObjectFieldOp(result=result, object=object, fieldPath=field_path, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ObjectOp(_ods_ir.OpView):
  OPERATION_NAME = "om.object"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, className, actualParams, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(actualParams))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["className"] = (className if (
    issubclass(type(className), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('SymbolNameAttr')) else
      _ods_ir.AttrBuilder.get('SymbolNameAttr')(className, context=_ods_context))
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def actualParams(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def className(self):
    return self.operation.attributes["className"]

  @className.setter
  def className(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["className"] = value

  @builtins.property
  def result(self):
    return self.operation.results[0]

def object(result, class_name, actual_params, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(ObjectOp(result=result, className=class_name, actualParams=actual_params, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class PathCreateOp(_ods_ir.OpView):
  OPERATION_NAME = "om.path_create"

  _ODS_REGIONS = (0, True)

  def __init__(self, targetKind, basePath, target, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(basePath))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["targetKind"] = (targetKind if (
    issubclass(type(targetKind), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('TargetKind')) else
      _ods_ir.AttrBuilder.get('TargetKind')(targetKind, context=_ods_context))
    attributes["target"] = (target if (
    issubclass(type(target), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('FlatSymbolRefAttr')) else
      _ods_ir.AttrBuilder.get('FlatSymbolRefAttr')(target, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def basePath(self):
    return self.operation.operands[0]

  @builtins.property
  def targetKind(self):
    return self.operation.attributes["targetKind"]

  @targetKind.setter
  def targetKind(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["targetKind"] = value

  @builtins.property
  def target(self):
    return self.operation.attributes["target"]

  @target.setter
  def target(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["target"] = value

  @builtins.property
  def result(self):
    return self.operation.results[0]

def path_create(target_kind, base_path, target, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(PathCreateOp(targetKind=target_kind, basePath=base_path, target=target, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class TupleCreateOp(_ods_ir.OpView):
  OPERATION_NAME = "om.tuple_create"

  _ODS_REGIONS = (0, True)

  def __init__(self, inputs, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(inputs))
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def inputs(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def result(self):
    return self.operation.results[0]

def tuple_create(inputs, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(TupleCreateOp(inputs=inputs, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class TupleGetOp(_ods_ir.OpView):
  OPERATION_NAME = "om.tuple_get"

  _ODS_REGIONS = (0, True)

  def __init__(self, input, index, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(input))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["index"] = (index if (
    issubclass(type(index), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('I32Attr')) else
      _ods_ir.AttrBuilder.get('I32Attr')(index, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def input(self):
    return self.operation.operands[0]

  @builtins.property
  def index(self):
    return self.operation.attributes["index"]

  @index.setter
  def index(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["index"] = value

  @builtins.property
  def result(self):
    return self.operation.results[0]

def tuple_get(input, index, *, loc=None, ip=None) -> _SubClassValueT:
  return _get_op_result_or_op_results(TupleGetOp(input=input, index=index, loc=loc, ip=ip))
